//Bluetooth disables ADC2 port so GPIOs 0, 2, 4, 12 - 15 and 25 - 27 can't be used with either wifi or bluetooth.
//Uncomment to able Serial communication

//DA FARE:
//togliere pulsecounter interrupt Counterflow
//inserire salvataggio encoderCounter EEPROM
//wi fi feature
//...più in la.. collegare crepuscolare esterno per luce cortesia
//se cambio variabilie "verso" salta l'azione del primo pulsante sia da terra che da app


//----- Star Pulse Counter (PCNT) setting for Encoder ---------------

#include "driver/pcnt.h"  // ESP32 library for pulse count
// e.g. stored in following path C:\Users\User\Documents\Arduino\hardware\arduino-esp32-master\tools\sdk\include\driver\driver\pcnt.h
// when in the Arduino IDE properties the sketchbook storage location is set to C:\Users\User\Documents\Arduino

#define PCNT_FREQ_UNIT      PCNT_UNIT_0                      // select ESP32 pulse counter unit 0 (out of 0 to 7 indipendent counting units)
// https://docs.espressif.com/projects/esp-idf/en/latest/esp32/api-reference/peripherals/pcnt.html

int ENCODER_PIN = 15;                                 // Input D15 = signal from encoder for pulse counter

int16_t PulseCounter =     0;                                // pulse counter, max. value is 65536
int OverflowCounter =      0;                                // pulse counter overflow counter
int PCNT_H_LIM_VAL =       10; //10000;                            // upper limit of counting  max. 32767, write +1 to overflow counter, when reached
uint16_t PCNT_FILTER_VAL =  1000;                            // filter (damping, inertia) value for avoiding glitches in the count, max. 1023

pcnt_isr_handle_t user_isr_handle = NULL;                    // interrupt handler - not used
hw_timer_t * timer = NULL;                                   // Instancia do timer

void IRAM_ATTR CounterOverflow(void *arg) {                  // Interrupt for overflow of pulse counter
  OverflowCounter = OverflowCounter + 1;                     // increase overflow counter
  PCNT.int_clr.val = BIT(PCNT_FREQ_UNIT);                    // clean overflow flag
  pcnt_counter_clear(PCNT_FREQ_UNIT);                        // zero and reset of pulse counter unit
}

void initPulseCounter () {                                   // initialise pulse counter
  pcnt_config_t pcntFreqConfig = { };                        // Instance of pulse counter
  pcntFreqConfig.pulse_gpio_num = ENCODER_PIN;               // pin assignment for pulse counter = GPIO 15
  pcntFreqConfig.pos_mode = PCNT_COUNT_INC;                  // count rising edges (=change from low to high logical level) as pulses
  pcntFreqConfig.counter_h_lim = PCNT_H_LIM_VAL;             // set upper limit of counting
  pcntFreqConfig.unit = PCNT_FREQ_UNIT;                      // select ESP32 pulse counter unit 0
  pcntFreqConfig.channel = PCNT_CHANNEL_0;                   // select channel 0 of pulse counter unit 0
  pcnt_unit_config(&pcntFreqConfig);                         // configur rigisters of the pulse counter

  pcnt_counter_pause(PCNT_FREQ_UNIT);                        // pause puls counter unit
  pcnt_counter_clear(PCNT_FREQ_UNIT);                        // zero and reset of pulse counter unit

  pcnt_event_enable(PCNT_FREQ_UNIT, PCNT_EVT_H_LIM);         // enable event for interrupt on reaching upper limit of counting
  pcnt_isr_register(CounterOverflow, NULL, 0, &user_isr_handle);  // configure register overflow interrupt handler
  pcnt_intr_enable(PCNT_FREQ_UNIT);                          // enable overflow interrupt

  pcnt_set_filter_value(PCNT_FREQ_UNIT, PCNT_FILTER_VAL);    // set damping, inertia
  pcnt_filter_enable(PCNT_FREQ_UNIT);                        // enable counter glitch filter (damping)

  pcnt_counter_resume(PCNT_FREQ_UNIT);                       // resume counting on pulse counter unit
}

void Read_Reset_PCNT() {                                     // function for reading pulse counter (for timer)
  pcnt_get_counter_value(PCNT_FREQ_UNIT, &PulseCounter);     // get pulse counter value - maximum value is 16 bits

  // resetting counter as if example, delete for application in PiedPiperS
  OverflowCounter = 0;                                       // set overflow counter to zero
  pcnt_counter_clear(PCNT_FREQ_UNIT);                        // zero and reset of pulse counter unit
}

void Read_PCNT() {                                           // function for reading pulse counter (for timer)
  pcnt_get_counter_value(PCNT_FREQ_UNIT, &PulseCounter);     // get pulse counter value - maximum value is 16 bits
}

void Reset_PCNT() {                                     // function for reading pulse counter (for timer)
  // resetting counter as if example, delete for application in PiedPiperS
  OverflowCounter = 0;                                       // set overflow counter to zero
  pcnt_counter_clear(PCNT_FREQ_UNIT);                        // zero and reset of pulse counter unit
}

#define GARAGE_MAX 164 //max 166
#define GARAGE_MIN 0

int encoderCounter = 0;
int PCNTencoderCounter = 0;

unsigned long currentMillis = 0;
unsigned long previousMillis = 0;        // will store last time Encoder value was updated

// constants won't change:
const long interval = 2000;           // interval at which update Encoder Value and BT app

//----- End Pulse Counter (PCNT) setting for Encoder ---------------
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//--- motor control settings

#define enable 25
#define motorA 33
#define motorB 32

bool motorControl = false;
bool verso = true; //control of motor's direction
bool preStart = false; //variabile ausiliaria per verificare la prima accensione del motore

// setting PWM properties
const int freq = 20000;
const int channel = 0;
const int resolution = 8;

//duty cicle
const int PWM = 204; //to obtain 18V from 24V

const int intervalMotor = 40;

//--- END motor control settings

//|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

//------------   Android App

// Include necessary libraries
#include <BLEDevice.h>
#include <BLEServer.h>
#include <BLEUtils.h>
#include <BLE2902.h>

// DO NOT CHANGE THE NEXT UUIDs
// Otherwise, you also need to modify the Android application used in this project
#define SERVICE_UUID "C6FBDD3C-7123-4C9E-86AB-005F1A7EDA01"
#define CHARACTERISTIC_UUID_RX "B88E098B-E464-4B54-B827-79EB2B150A9F"
#define CHARACTERISTIC_UUID_TX "D769FACF-A4DA-47BA-9253-65359EE480FB"



BLECharacteristic *pCharacteristic;
bool deviceConnected = false;

// Setup callbacks onConnect and onDisconnect
class MyServerCallbacks: public BLEServerCallbacks {
    void onConnect(BLEServer* pServer) {
      deviceConnected = true;
    };
    void onDisconnect(BLEServer* pServer) {
      deviceConnected = false;
    }
};
// Setup callback when new value is received (from the Android application)
class MyCallbacks: public BLECharacteristicCallbacks {
    void onWrite(BLECharacteristic *pCharacteristic) {
      std::string rxValue = pCharacteristic->getValue();
      if (rxValue.length() > 0) {
        //        Serial.print("\n\n\n\nValore ricevuto APP: ");
        //        for (int i = 0; i < rxValue.length(); i++) {
        //          Serial.print(rxValue[i]);
        //        }
        // Turn the Garage ON or OFF according to the command received
        if (rxValue.find("ON") != -1) {
          //          Serial.println(" - Garage ON\n");
          motorControl = true;
        }
        else if (rxValue.find("OFF") != -1) {
          //          Serial.println(" - Garage OFF\n");
          motorControl = false;
        }
      }
    }
};

//----------- END Android App
//||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

// ----------- Button setting and Outdoor + Indoor Light setting

#include <ezButton.h>

#define DEBOUNCE_TIME 50 // the debounce time in millisecond, increase this time if it still chatters

ezButton button(21); // create ezButton object that attach to pin GIOP21


#define ledPin 2

// setting PWM properties
const int LEDfreq = 1000;
const int LEDchannel = 1;

//duty cicle
int lightPWM = 200;  //78%

#define relayLight 4

// ---------- End Button and Lights setting

void setup() {

  Serial.begin(115200);

  // Create the BLE Device
  BLEDevice::init("ESP32_Board");
  // Create the BLE Server
  BLEServer *pServer = BLEDevice::createServer();
  pServer->setCallbacks(new MyServerCallbacks());
  // Create the BLE Service
  BLEService *pService = pServer->createService(SERVICE_UUID);
  // Create a BLE Characteristic
  pCharacteristic = pService->createCharacteristic(
                      CHARACTERISTIC_UUID_TX,
                      BLECharacteristic::PROPERTY_NOTIFY);

  pCharacteristic->addDescriptor(new BLE2902());
  BLECharacteristic *pCharacteristic = pService->createCharacteristic(
                                         CHARACTERISTIC_UUID_RX,
                                         BLECharacteristic::PROPERTY_WRITE)
                                       ;
  pCharacteristic->setCallbacks(new MyCallbacks());
  // Start the service
  pService->start();
  // Start advertising
  pServer->getAdvertising()->start();
  //  Serial.println("Waiting to connect...");


  // Motor Control setup --------------
  pinMode(enable, OUTPUT);
  pinMode(motorA, OUTPUT);
  pinMode(motorB, OUTPUT);

  digitalWrite(enable, LOW);
  digitalWrite(motorA, LOW);
  digitalWrite(motorB, LOW);

  // configure Motor PWM functionalitites
  ledcSetup(channel, freq, resolution);

  // attach the Motor channel to the GPIO to be controlled
  ledcAttachPin(enable, channel);


  //Button and Lights setup ----------
  
  button.setDebounceTime(DEBOUNCE_TIME); // set debounce time to 50 milliseconds

  // configure LED PWM functionalitites
  ledcSetup(LEDchannel, LEDfreq, resolution);
  // attach the LED channel to the GPIO to be controlled
  ledcAttachPin(ledPin, LEDchannel);
  luceCortesia(LOW);

  pinMode(relayLight, OUTPUT);
  digitalWrite(relayLight, LOW);
}


void loop() {

  controlloManuale();

  if (!motorControl) {

    // When the device is connected to the App throught BT
    if (deviceConnected) {

      unsigned long currentMillis = millis();

      if (currentMillis - previousMillis >= interval) {
        // save the last time you ...
        previousMillis = currentMillis;

        // Convert the value to a char array
        char txString[8];
        dtostrf(encoderCounter, 1, 0, txString);

        // Set new characteristic value
        pCharacteristic->setValue(txString);
        // Send the value to the Android application
        pCharacteristic->notify();
        Serial.print("Valore Encoder inviato: ");
        Serial.println(txString);
      }
    }
  }

  controlloMotore(motorControl);
}


void controlloManuale() {
  button.loop(); // MUST call the loop() function first

  if (button.isPressed()) motorControl = !motorControl;
}


void controlloMotore(bool control) {
  if (control && (encoderCounter < GARAGE_MAX && encoderCounter >= GARAGE_MIN) ) motore(verso);
  else motoreFermo();
}


void motore(bool dir) {
  //turn on relay
  digitalWrite(relayLight, HIGH);

  //turn on LED light
  luceCortesia(HIGH);

  //To obtain a slow motor start, the PWM will increase gradually
  if (!preStart) {
    //ovviamente questa istruzione va ripetuta una SOLA volta per ogni avvio del motore
    //verso = !verso;
    Serial.println("motore - prestart");
    Serial.print("     >");
    Serial.println();

    initPulseCounter();
    int f = 48;

    while ( f < PWM ) { //cambia con if
      unsigned long currentMillis = millis();

      if (currentMillis - previousMillis >= intervalMotor) {
        // save the last time you ...
        previousMillis = currentMillis;

        ledcWrite(channel, f);
        f += 12;
      }
    }
    preStart = true; //if( f >= PWM) 
    Serial.println("Fine - motore prestart");
  }

  Serial.print("Funzione motore  :");
  Serial.print(encoderCounter);
  Serial.print(" ----");
  Serial.println(PCNTencoderCounter);
  Serial.print("   ");
  Serial.println(dir);
  Serial.println((dir && ( (encoderCounter + PCNTencoderCounter) < GARAGE_MAX - 1)));
  Serial.println((!dir && ( (encoderCounter - PCNTencoderCounter) > GARAGE_MIN + 1)));

  if (dir && ( (encoderCounter + PCNTencoderCounter) < GARAGE_MAX - 1)) {
    digitalWrite(motorA, HIGH);
    digitalWrite(motorB, LOW);

    //f = 48;
    //deltaF = 12;

    Serial.println("Motore Avanti");
  }
  else if (!dir && ( (encoderCounter - PCNTencoderCounter) > GARAGE_MIN + 1)) {
    digitalWrite(motorA, LOW);
    digitalWrite(motorB, HIGH);

    //f = 36;
    //deltaF = 6;
    //intervalmotor = ???

    Serial.println("Motore Indietro");
  }
  else motoreFermo();


  Read_PCNT();
  PCNTencoderCounter = (OverflowCounter * PCNT_H_LIM_VAL) + PulseCounter;
}


void motoreFermo() {
  //set this variable as False to let then know the App the motor stopped
  motorControl = false;

  //Questa istruzione verrà ripetuta una sola volta dopo che il motore ha girato
  if (preStart) {

    if (verso) encoderCounter += PCNTencoderCounter;
    else encoderCounter -= PCNTencoderCounter;
    Read_Reset_PCNT();
    PCNTencoderCounter = 0;

    verso = !verso;
    Serial.println("verso cambiato");

    preStart = false;
  }
  //preStart = false;

  ledcWrite(channel, 0);

  digitalWrite(motorA, LOW);
  digitalWrite(motorB, LOW);

  //turn off relay
  digitalWrite(relayLight, LOW);

  //turn off LED light
  luceCortesia(LOW);

  Serial.println("Motore Fermo");
}


void luceCortesia(bool lightStat) {
  if(lightStat) ledcWrite(LEDchannel, lightPWM);
  else ledcWrite(LEDchannel, 0);
}
